/***********************************************************
 * tiutiu License ver.1.0.   see http://tiutiu.net/license/
 * Copyright(c) 2009, tiutiu.net all rights reserved.
 * 1. ۏ؂ƍ҂͐ӔC𕉂ȂƂ̏B
 * 2. hɂ͌̒쌠Ƌɖ{CZX̎gp/B
 * 3. 1,2ɔȂp𖳏ŋB
//*********************************************************/

#include <windows.h>
#include "mybitmap.h"

using namespace std;

LRESULT CALLBACK WindowProc(HWND hwnd,
							UINT message,
							WPARAM wparam,
							LPARAM lparam);

/* Window`֌W */
HRGN myCreateRegion(mybitmap &);

/* { */
int WINAPI WinMain(HINSTANCE hThisInstance,
				   HINSTANCE hPrevInstance, 
				   LPSTR     lpCmdLine,
				   int       nCmdShow) {
  /*
	int main(void) {
	HINSTANCE hThisInstance = GetModuleHandle(NULL);
	int nCmdShow = SW_SHOWDEFAULT;
	FreeConsole();
  */

  HWND      hWnd;
  WNDCLASSEX  wc;


  /* ǂȑ쐬邩 */
  wc.cbSize       = sizeof(WNDCLASSEX);
  wc.style        = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc  = (WNDPROC)WindowProc; /* 𐧌䂷֐o^ */
  wc.cbClsExtra   = 0;
  wc.cbWndExtra   = 0;
  wc.hInstance    = hThisInstance;
  wc.hIcon        = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor      = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  /* wc.hbrBackground = GetStockObject(WHITE_BRUSH);
   * gccŎgȂB
   */
  wc.lpszMenuName = NULL;
  wc.lpszClassName = "freestyle_window";
  wc.hIconSm      = LoadIcon(NULL, IDI_APPLICATION);

  RegisterClassEx(&wc);

  /* ł͑쐬܂傤! */
  hWnd = CreateWindow (wc.lpszClassName,
					   "freestyle window",
					   WS_POPUP | WS_SYSMENU,
					   CW_USEDEFAULT,   /* 쐬̉ʍ̈ʒu */
					   CW_USEDEFAULT,  /* 쐬̉ʏ̈ʒu */
					   16, /* ̕   */
					   16, /* ̍ */
					   (HWND)NULL,
					   (HMENU)NULL,
					   hThisInstance,
					   (LPVOID)NULL
					   );

  if(!hWnd) {
	  MessageBox( NULL, "̍쐬Ɏs!", "freestyle window", MB_OK );
	  return 0;
  }
  /* ͍ŏ͉BĂ̂ł\ */
  ShowWindow(hWnd, nCmdShow);

  /* ݂Ȃ̖߂󂯕t */
  MSG msg;
  while(GetMessage(&msg, NULL, 0, 0)) {
	TranslateMessage( &msg );
	DispatchMessage( &msg );
  }

  // MessageBox( NULL, "I܂B", "freestyle window", MB_OK );
  return 0;

} /* WinMain */


/* 𐧌䂷֐ */
LRESULT CALLBACK WindowProc(HWND hwnd,
							UINT message,
							WPARAM wparam,
							LPARAM lparam) { 
  HRGN hrgn;
  static mybitmap bmptiutiu("tiutiu.bmp");
  static HBITMAP  hbitmap;

  switch( message ) {

  case WM_CREATE:
	hrgn = myCreateRegion(bmptiutiu);
	SetWindowRgn(hwnd, hrgn, TRUE);

	/* rbg}bvf[^͈xƂ΂B*/
	hbitmap = (HBITMAP)LoadImage(0, "tiutiu.bmp",
								 IMAGE_BITMAP,
								 bmptiutiu.width,  /*    */
								 bmptiutiu.height, /*  */
								 LR_LOADFROMFILE
								 |LR_SHARED
								 |LR_VGACOLOR);
	break;

  case WM_PAINT:
	{
	  HDC         hdc_s, hdc_t;
	  PAINTSTRUCT paintstruct;

	  hdc_s = BeginPaint( hwnd, &paintstruct );
	  hdc_t = CreateCompatibleDC( hdc_s );
	  SelectObject( hdc_t, hbitmap );
	  BitBlt(hdc_s, /* Rs[ */
			 0,     /* x */
			 0,     /* y */
			 bmptiutiu.width,    /*    */
			 bmptiutiu.height,   /*  */
			 hdc_t, /* Rs[ */
			 0,     /* Rs[x */
			 0,     /* Rs[y */
			 SRCCOPY); /* Rs[`Rs[撷`ւ̂܂܃Rs[ */

	  DeleteDC( hdc_t );
	  EndPaint(hwnd, &paintstruct);
	}
	break;

  case WM_NCHITTEST:
	/* NCAg̈ŃEBhEړ */
	wparam = DefWindowProc(hwnd, message, wparam, lparam);
	if ( wparam == HTCLIENT )
	  return HTCAPTION;
	else
	  return wparam;
	break;

  case WM_DESTROY:
	/* ܂ǂɕ\Ă摜폜 */
	DeleteObject( hbitmap );

	PostQuitMessage( 0 );
	break;

  default:
	return DefWindowProc(hwnd,message,wparam,lparam);
  }

  return FALSE;
} /* WindowProc */


/* EBhE`֌W */
HRGN myCreateRegion(mybitmap &bmptiutiu) {

  HRGN    hrgn;
  RGNDATA *pr;
  RECT    *prect;
  int     MAX_RECT_COUNT = 300;
  DWORD   rgndatasize;
  int     h,w,t,y;
  int     left_x  =  -1;
  int     top_y   =  -1;
  int     right_x =  -1;
  int     bottom_y = -1;
  DWORD   c, transparentcolor;

  rgndatasize = sizeof(RGNDATAHEADER)
	+ sizeof(RECT)*bmptiutiu.width*bmptiutiu.height;

  pr = (RGNDATA *)malloc(rgndatasize);
  /* MAX_RECT_COUNT͂Ƃ肷Ƃv */
  /* [Wf[^\̂̃wb_` */
  (pr->rdh).dwSize = sizeof(RGNDATAHEADER);  /* قڌ܂肨܂Ȃ */
  (pr->rdh).iType  = RDH_RECTANGLES;         /* Œ炵B         */
  (pr->rdh).nCount = 0;                      /* [W쐬钷`̐
											  * ƂŒ`ȂB */
  (pr->rdh).nRgnSize = 0;                    /* oオ̃[W
											  * ̑傫BsȂ̂0
											  * 悢炵 */
  SetRect(&((pr->rdh).rcBound), 0,0,0,0);    /* oオ[W
											  * `̋E
											  * ƂōĐݒ */

  /* f[^AĂB
   * ォ牺, E֍sExtCreateRegionŌ悭
   * ł炵
   */
  prect = (RECT *)&pr->Buffer[0];

  /* bitmap̃f[^\͉, E֍sB
   * 1s4̔{őȂꍇ0pfBOB
   */
  /* Ƃ肠̐F𓧉ߐFƂB*/
  t = (bmptiutiu.height-1)*bmptiutiu.line_per_length;
  transparentcolor =
	((DWORD)bmptiutiu.bitmap_data[t]<<16)
	+ ((DWORD)bmptiutiu.bitmap_data[t+1]<<8)
	+ ((DWORD)bmptiutiu.bitmap_data[t+2]);
  /* 
	 char m[80];
	 wsprintf(m,
	 "%2X,%2X,%2X",
	 bmptiutiu.bitmap_data[t],
	 bmptiutiu.bitmap_data[t+1],
	 bmptiutiu.bitmap_data[t+2]);
	 MessageBox(NULL, m, "test", MB_OK);
  */

  for(h=bmptiutiu.height-1,y=0;h>=0;h--,y++) {
	t=h*bmptiutiu.line_per_length;
	for(w=0;w<bmptiutiu.width;w++) {
	  c = ((DWORD)bmptiutiu.bitmap_data[t]<<16)
		+ ((DWORD)bmptiutiu.bitmap_data[t+1]<<8)
		+ ((DWORD)bmptiutiu.bitmap_data[t+2]);
	  t += 3;
	  /* ߐFȂ̂ŉȂ */
	  if(c==transparentcolor) continue;

	  /* ߐFłȂ烊[Wf[^ݒ */
	  SetRect(prect++, w, y, w+1, y+1);  (pr->rdh).nCount++;
	  if(left_x  <0 || left_x>w  ) left_x   = w;
	  if(right_x <0 || right_x<w ) right_x  = w;
	  if(top_y   <0 || top_y>y   ) top_y    = y;
	  if(bottom_y<0 || bottom_y<y) bottom_y = y;
	}
  }

  /* oオ[W̒`̋E */
  SetRect(&((pr->rdh).rcBound), left_x,top_y,right_x,bottom_y);    

  /* [W쐬 */
  hrgn = ExtCreateRegion(NULL,         /* NULL */
						 rgndatasize,  /* ꂩnRGNDATȂ傫 */
						 pr);          /* RGNDATA */

  return hrgn;
} /* myCreateRegion */

/* end */
